%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This program is used to prepare Staff forecast data as well as
% to produce econometric benchmark forecasts for further analysis
% Bank of Canada Staff's economic forecasts
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

PARAMS.start = 'jun82'; % Refers to the first vintage from which you want to use forecasts. 
                        % Will cut all forecasts prior to this one. First available is mar74

PARAMS.end = 'dec13'; % Refers to the last vintage from which you want to use forecasts.
                      % Will cut all data after to this one. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Read data

Read_Data

%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generate RT and Final data matrices

Gen_RT_Final_Data

%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generate RT data with different jump-off delays

Gen_RT_benchmark_data

%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generate RT benchmark econometric estimates

Gen_benchmarks


clearvars -except PARAMS *DATA* vintages RT_DATA FINAL*_DATA*

